Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO2.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO2.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO2.m	(revision 636)
@@ -1,43 +1,26 @@
 RAHLO2 ;HIRMFO/GJC-File rpt (data from bridge program) ;10/30/97  09:02
- ;;5.0;Radiology/Nuclear Medicine;**55,80,84**;Mar 16, 1998;Build 13
- ;
- ;Integration Agreements
- ;----------------------
- ;$$FIND1^DIC(2051); UPDATE^DIE(2053); $$DT^XLFDT(10103); $$UP^XLFSTR(10104)
- ;
-ADENDUM ; This functions store new lines of text at the end of the existing 
- ;impression and report text. If this report is being amended through the
- ;teleradiology service, add the addendum text to the IMPRESSION TEXT (#300)
- ;field only. Note: Only ADENDUM was edited for RA*5.0*84 gjc/09.18.07
- N A,COUNTER,I,J,NODE,ROOT,SUB,X,Y
- ;NODE = ^RARPT(RARPT,"I" -or- "R"  -> where the data is to be stored...
- ;ROOT = ^TMP("RARPT-REC",$J,RASUB  -> where the addendum data resides...
- F A="I","R" D  K I,J
- .S SUB=$S(A="I":"RAIMP",1:"RATXT"),ROOT=$NA(^TMP("RARPT-REC",$J,RASUB,SUB)) Q:'$O(@ROOT@(0))
- .S NODE=$NA(^RARPT(RARPT,A))
- .S COUNTER=+$O(@NODE@($C(32)),-1) ;last record #
- .;
- .;if there is existing text, add a null line for space.
- .I '($D(I)#2),(COUNTER>0) S COUNTER=COUNTER+1,@NODE@(COUNTER,0)=$C(32),I=""
- .;
- .S Y=0 F  S Y=$O(@ROOT@(Y)) Q:'Y  D
- ..S X=@ROOT@(Y)
- ..;if addendum text is to be the original text no spacer is needed ('Addendum:' tag applied)
- ..;if prior report or impression text exist, insert a blank as a spacer
- ..;^RARPT(RARPT,"I",1,0)="original impression"
- ..;^RARPT(RARPT,"I",2,0)="" <- insert a null line as a spacer
- ..;^RARPT(RARPT,"I",3,0)="Addendum: first line of addendum" ** NOTE 'Addendum:' tag **
- ..;^RARPT(RARPT,"I",4,0)="second line of addendum"
- ..;...
- ..;^RARPT(RARPT,"I",N,0)="Nth and last line of addendum"
- ..S COUNTER=COUNTER+1
- ..;set the first line of the addendum w/header: 'Addendum: '
- ..I '($D(J)#2) S X="Addendum: "_X,J=""
- ..S @NODE@(COUNTER,0)=X
- ..Q
- .S @NODE@(0)="^^"_COUNTER_"^"_COUNTER_"^"_$$DT^XLFDT()
- .Q
+ ;;5.0;Radiology/Nuclear Medicine;**55,80**;Mar 16, 1998;Build 19
+ADENDUM ; store new lines at the end of existing text
+ F A="I","R" D
+ . I $O(^TMP("RARPT-REC",$J,RASUB,$S(A="I":"RAIMP",1:"RATXT"),0)) D
+ .. S RACNT=+$O(^RARPT(RARPT,A,9999999),-1),RASTRNDE=RACNT+1
+ .. ; Check if the impression an/or report text sent with the addendum
+ .. ; is to be the initial text added to the word processing multiples.
+ .. ; RASTRNDE=the first subscript where impression/report data is to
+ .. ; be stored.  If no existing impression/report text data, RASTRNDE
+ .. ; equals one.  If one & RACNT equals one, don't add a blank line
+ .. ; before adding addendum text.  If RASTRNDE & RACNT both >1, add
+ .. ; the blank line.
+ .. S I=0 F  S I=$O(^TMP("RARPT-REC",$J,RASUB,$S(A="I":"RAIMP",1:"RATXT"),I)) Q:I'>0  D
+ ... S RACNT=RACNT+1,L=$G(^TMP("RARPT-REC",$J,RASUB,$S(A="I":"RAIMP",1:"RATXT"),I))
+ ... S:I=$O(^TMP("RARPT-REC",$J,RASUB,$S(A="I":"RAIMP",1:"RATXT"),0)) L="Addendum: "_L ; if the first line, append 'addendum:'
+ ... I (RASTRNDE=RACNT),(RACNT>1) S ^RARPT(RARPT,A,RACNT,0)=" ",RACNT=RACNT+1
+ ... S ^RARPT(RARPT,A,RACNT,0)=L
+ ... Q
+ .. S ^RARPT(RARPT,A,0)="^^"_RACNT_"^"_RACNT_"^"_RADATE
+ .. Q
+ . Q
+ K A,I,L,RACNT,RASTRNDE
  Q
- ;
 ERR(A) ; Invalid impression/report text message.
  ; Input: 'A' - either "I" for impression, or "R" for report
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO3.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO3.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO3.m	(revision 636)
@@ -1,17 +1,11 @@
 RAHLO3 ;HIRMFO/GJC-Process data set from the bridge program ;11/18/97  12:13
- ;;5.0;Radiology/Nuclear Medicine;**4,81,84**;Mar 16, 1998;Build 13
- ;
- ;Integration Agreements
- ;-----------------------
- ;$$GET1^DIQ(2056); $$DT^XLFDT(10103)
- ;
+ ;;5.0;Radiology/Nuclear Medicine;**4,81**;Mar 16, 1998;Build 12
 RPTSTAT ; Determine the status to set this report to.
  K RARPTSTS S:$D(RAESIG) RARPTSTS="V" Q:$D(RARPTSTS)
  ; $D(RAESIG)=0 now figure out report status
- N RASTAT S RASTAT=$E($G(^TMP("RARPT-REC",$J,RASUB,"RASTAT")))
+ S RASTAT=$E($G(^TMP("RARPT-REC",$J,RASUB,"RASTAT")))
  I RASTAT="A" S RARPTSTS="V" Q
  I RASTAT]"",("FR"[RASTAT) D
  . S:RASTAT="F" RARPTSTS="V" Q:$D(RARPTSTS)
- . I $G(RATELE) S RARPTSTS="R" Q  ;Always allow 'Released/Unverified' reports for teleradiology
  . ; do we allow 'Released/Unverified' reports for this location?
  . S RARPTSTS=$S($P($G(^RA(79.1,RAMLC,0)),"^",17)="Y":"R",1:"D")
@@ -21,4 +15,5 @@
  ; if still no status, default to draft
  S:'$D(RARPTSTS) RARPTSTS="D"
+ K RASTAT
  Q
 TEXT(X) ; Check if the Impression Text and the Report Text contain
@@ -47,21 +42,21 @@
  ; If 'No' to any of the above questions, kill RAESIG & set the variable
  ; RAERR to the appropriate error message.
- I '$D(^VA(200,"ARC","R",+$G(RAVERF))),('$D(^VA(200,"ARC","S",+$G(RAVERF)))),'$G(RATELE) D  Q
+ I '$D(^VA(200,"ARC","R",+$G(RAVERF))),('$D(^VA(200,"ARC","S",+$G(RAVERF)))) D  Q
  . ; neither a resident or staff
  . K RAESIG S RAERR="Provider not classified as resident or staff."
  . Q
- I $D(^VA(200,"ARC","R",+$G(RAVERF))),('$P(RAMDV,"^",18)),'$G(RATELE) D  Q
+ I $D(^VA(200,"ARC","R",+$G(RAVERF))),('$P(RAMDV,"^",18)) D  Q
  . ; residents can't verify reports linked to this division
  . K RAESIG S RAERR="Residents are not permitted to verify reports."
  . Q
- I '$D(^XUSEC("RA VERIFY",+$G(RAVERF))),'$G(RATELE) D  Q
+ I '$D(^XUSEC("RA VERIFY",+$G(RAVERF))) D  Q
  . ; verifier MUST have the RA VERIFY key.
  . K RAESIG S RAERR="Provider does not meet security requirements to verify report."
  . Q
- I '$G(RATELE),$P($G(^VA(200,+$G(RAVERF),"RA")),"^",3),($P(^("RA"),"^",3)'>$$DT^XLFDT()) D
+ I $P($G(^VA(200,+$G(RAVERF),"RA")),"^",3),($P(^("RA"),"^",3)'>$$DT^XLFDT()) D
  . ; Rad/Nuc Med user has been inactivated.
  . K RAESIG S RAERR="Inactive Rad/Nuc Med Classification for Interpreting Physician."
  . Q
- I '$G(RATELE),'$S('$D(^VA(200,+$G(RAVERF),"RA")):1,$P(^("RA"),"^")'="Y":1,1:0) D
+ I '$S('$D(^VA(200,+$G(RAVERF),"RA")):1,$P(^("RA"),"^")'="Y":1,1:0) D
  . K RAESIG S RAERR="Staff review required to verify report."
  . Q
@@ -94,8 +89,7 @@
  . I RAVCNT=1,('$D(RAVIEN(RAVCNT))#2) S RAVIEN(RAVCNT)=RAVIEN
  . Q
- I RAVCNT=0 S RAERR="Invalid Provider Name: "_RAVERF Q  ; partial match not found
- I RAVCNT>1 S RAERR="Non-Unique Provider Name: "_RAVERF Q  ; >1 partial match
- ;S RAVERF=$G(RAVIEN(1)) S:'RAVERF RAERR="Provider Name Entry Error"
- S:'$G(RAVIEN(1)) RAERR="Provider Name Entry Error: "_RAVERF S RAVERF=$G(RAVIEN(1))
+ I RAVCNT=0 S RAERR="Invalid Provider Name" Q  ; partial match not found
+ I RAVCNT>1 S RAERR="Non-Unique Provider Name" Q  ; >1 partial match
+ S RAVERF=$G(RAVIEN(1)) S:'RAVERF RAERR="Provider Name Entry Error"
  Q
 ESIG ; Added for COTS E-Sig capability
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO4.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO4.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLO4.m	(revision 636)
@@ -1,14 +1,7 @@
 RAHLO4 ;HIRMFO/GJC-File rpt (data from bridge program) ;7/21/99  11:45
- ;;5.0;Radiology/Nuclear Medicine;**4,8,81,84**;Mar 16, 1998;Build 13
- ;
- ;Integration Agreements
- ;----------------------
- ;NOW^%DTC(10000); %ZTLOAD(10063); FIND^DIC(2051); ^DIE(10018); ^DIK(10013); $$GET1^DIQ(2056)
- ;GETS^DIQ(2056); ^XMD(10070)
- ;
+ ;;5.0;Radiology/Nuclear Medicine;**4,8,81**;Mar 16, 1998;Build 12
 TASK ; Task ORU message
  S ZTDESC="Rad/Nuc Med Compiling HL7 ORU Message",ZTDTH=$H,ZTIO="",ZTRTN="RPT^RAHLRPC",ZTSAVE("RADFN")="",ZTSAVE("RADTI")="",ZTSAVE("RACNI")="",ZTSAVE("RARPT")=""
- ;Next line of coding will assure that ORU (report) message will be sent after posible ORM message. (10 second)
- S $P(ZTDTH,",",2)=$P(ZTDTH,",",2)+4 S:$P(ZTDTH,",",2)>86400 ZTDTH=$P(ZTDTH,",")+1_","_($P(ZTDTH,",",2)-86400)
+ ;S:$L($G(RANOSEND))&'$O(RAPRSET(RADTI,0)) ZTSAVE("RANOSEND")="" D ^%ZTLOAD
  S:$L($G(RANOSEND)) ZTSAVE("RANOSEND")="" D ^%ZTLOAD
  K ZTDESC,ZTDTH,ZTIO,ZTRTN,ZTSAVE
@@ -22,5 +15,8 @@
  D ^%ZTLOAD K RAMES,ZTDESC,ZTSK,ZTIO,ZTSAVE,ZTRTN,RASV,ZTDTH
  Q
- ;
+FILETST ; is anyone else working on this report?
+ L +^RARPT(RARPT):1
+ I '$T S RAERR="This report is being edited by another user" L -^RARPT(RARPT)
+ Q
 UPMEM ;copy (prim:dx,stf,res),rpt ien to other members of same print set
  ; first clear those fields
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLR.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLR.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLR.m	(revision 636)
@@ -1,4 +1,4 @@
 RAHLR ;HISC/CAH/BNT - Generate Common Order (ORM) Message ;11/10/99  10:42
- ;;5.0;Radiology/Nuclear Medicine;**2,12,10,25,71,82,75,80,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**2,12,10,25,71,82,75,80**;Mar 16, 1998;Build 19
  ;Generates msg whenever a case is registered or cancelled or examined
  ;              registered        cancelled        examined
@@ -6,15 +6,4 @@
  ; Order status  : IP                CA               CM
  ;02/14/2006 BAY/KAM RA*5*71 Add ability to update exam data to V/R
- ;
- ;Integration Agreements
- ;----------------------
- ;NOW^%DTC(10000); ^%ZTLOAD(10063); $$GET1^DIQ(2056); ^DIWP(10011)
- ;$$HLDATE/$$HLNAME/$$M11^HLFNC(10106); INIT^HLFNC2(2161)
- ;GENERATE^HLMA(2164); DEM^VADPT(10061); $$EN^VAFHLPID(263)
- ;$$FMTHL7^XLFDT(10103)
- ;
- ;IA: 10039 global read .01 field WARD LOCATION (#42) file ^DIC(42,
- ;IA: 10040 global read .01 field HOSPITAL LOCATION (#44) file ^SC(
- ;
  S:$D(HLNDAP) ZTSAVE("HLNDAP")="" S:$D(HLDAP) ZTSAVE("HLDAP")="" S:$D(RAEXMDUN) ZTSAVE("RAEXMDUN")=""
  S:$D(RAEXEDT) ZTSAVE("RAEXEDT")=""
@@ -36,7 +25,7 @@
  ;RAEXMDUN passed from EXM^RAHLRPC if conditions are met
  Q:+$G(HL)=15  ;no known client(item) linked to the event driver protocol
- Q:$O(HL(""))=""  ;disabled server appl, or no server appl 
+ Q:$O(HL(""))=""  ;disabled server appl, or no server appl
  ;** branch to new HL7 logic when the HL7 version surpasses 2.3 **
- I HL("VER")>2.3,($T(^RAHLR1))'="" D EN^RAHLR1(RADFN,RADTI,RACNI,RAEID) Q
+ ;I HL("VER")]2.3 D EN^RAHLR1(RADFN,RADTI,RACNI,RAEID) Q
  ;** branch to new HL7 logic when the HL7 version surpasses 2.3 **
  S RACN0=$S($D(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0)):^(0),1:"") Q:RACN0']""
@@ -47,5 +36,5 @@
  S RAPRCNDE=$G(^RAMIS(71,+RAPROC,0)),RACPT=+$P(RAPRCNDE,U,9),RACPTNDE=$$NAMCODE^RACPTMSC(RACPT,DT)
  ;RA*5*82 RAEXEDT= Override the EXM conditions if Case edited
- ;I $G(RAEXMDUN)=1,'$G(RAEXEDT),$P(RACN0,U,30)'="",'$G(RATELE) Q  ;last chance to stop exm'd msg if it's already been sent RA*5*84 Is TELERAD ?? 
+ I $G(RAEXMDUN)=1,'$G(RAEXEDT),$P(RACN0,U,30)'="" Q  ;last chance to stop exm'd msg if it's already been sent
  ;Compile 'PID' Segment
  K VA,VADM,VAERR,RAVADM S DFN=RADFN D DEM^VADPT I VADM(1)']"" S HLP("ERRTEXT")="Invalid Patient Identifier" G EXIT
@@ -73,8 +62,5 @@
  ; S RAOBR4=$P(RACPTNDE,U)_$E(HLECH)_$$ESCAPE^RAHLRU($P(RACPTNDE,U,2))_$E(HLECH)_"C4"_$E(HLECH)_+RAPROC_$E(HLECH)_$$ESCAPE^RAHLRU($P(RAPRCNDE,U))_$E(HLECH)_"99RAP"
  I $P(RACPTNDE,U)']"" S $P(RAOBR4,$E(HLECH),1,3)=$P(RAOBR4,$E(HLECH),4,5)_$E(HLECH)_"LOCAL"
- ;OBR-7 change: from HLDT1 to $$HLDATE^HLFNC(9999999.9999-RADTI) d/t of registration
- ;Driver of change: CareStream Health PACS. Agfa requires a timestamp down to the second
- ;POC @ Boston is Maureen Sullivan
- S HLA("HLS",3)="OBR"_HLFS_HLFS_RADTE_HLFS_RADTI_"-"_RACNI_$E(HLECH)_RADTE_$E(HLECH)_"L"_HLFS_RAOBR4_HLFS_HLFS_HLFS_$$HLDATE^HLFNC(9999999.9999-RADTI)
+ S HLA("HLS",3)="OBR"_HLFS_HLFS_RADTE_HLFS_RADTI_"-"_RACNI_$E(HLECH)_RADTE_$E(HLECH)_"L"_HLFS_RAOBR4_HLFS_HLFS_HLFS_HLDT1
  S HLA("HLS",3)=HLA("HLS",3)_HLFS_HLQ_HLFS_HLQ_HLFS_HLFS_HLFS_HLFS_HLFS_HLQ_HLFS_HLFS
  S RAPRV=$$GET1^DIQ(200,+$P(RACN0,"^",14),.01)
@@ -126,6 +112,5 @@
  N HLEID,HLARYTYP,HLFORMAT,HLMTIEN,HLP
  S HLEID=EID,HLARYTYP="LM",HLFORMAT=1,HLMTIEN="",HLP("PRIORITY")="I"
- D:$D(RASSSX(HLEID)) GETHLP^RAHLRS1(HLEID,.HLP,"RASSSX")
- D:$D(RASSSX1(HLEID)) GETHLP^RAHLRS1(HLEID,.HLP,"RASSSX1")
+ D:$D(RASSSX(HLEID)) GETHLP^RAHLRS1(HLEID,.HLP)
  D GENERATE^HLMA(HLEID,HLARYTYP,HLFORMAT,.HLRESLT,HLMTIEN,.HLP)
  Q
@@ -134,10 +119,9 @@
 INIT ; initialize HL7 variables
  D NOW^%DTC S HLDT=%,HLDT1=$$HLDATE^HLFNC(%)
- ;Note: HLDT1 is used for HL7 fields: ORC-9 & OBR-22
  Q:'$G(RAEID)  S EID=RAEID
  S HL="HLS(""HLS"")",INT=1
  D INIT^HLFNC2(EID,.HL,INT)
  Q:'$D(HL("Q"))  ;no server application defined
- S HLQ=HL("Q")
+ S HLQ=HL("Q"),HLFS=HL("FS")
  S HLECH=HL("ECH")
  S HLFS=HL("FS")
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPC.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPC.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPC.m	(revision 636)
@@ -1,33 +1,26 @@
 RAHLRPC ;HIRMFO/BNT-Rad/NM HL7 Protocol calls ;05/21/99   14:50
- ;;5.0;Radiology/Nuclear Medicine;**12,25,54,71,82,81,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**12,25,54,71,82,81**;Mar 16, 1998;Build 12
  ; 03/16/2006 *71 Rem Call 124379 allow exam updates to create HL7 msg
- ;
- ;Integration Agreements
- ;----------------------
- ;$$FIND1^DIC(2051); GETS^DIQ(2056)
- ;all access to ^ORD(101 to maintain application specific protocols(872)
- ;read w/FileMan HL7 APPLICATION PARAMETER(10136)
- ; 
 REG ; register exam
- N X,RA101Z,RAEID
- S RA101Z="RA REF" ; get all protocols beginning RA REG
- F  S RA101Z=$O(^ORD(101,"B",RA101Z)) Q:RA101Z'["RA REG"  D
- .S RAEID=$O(^ORD(101,"B",RA101Z,0))
+ N X,RAPID,RAEID
+ S RAPID="RA REF" ; get all protocols beginning RA REG
+ F  S RAPID=$O(^ORD(101,"B",RAPID)) Q:RAPID'["RA REG"  D
+ .S RAEID=$O(^ORD(101,"B",RAPID,0))
  .I RAEID,'$L($P(^ORD(101,RAEID,0),"^",3)) D EN^RAHLR
  Q
 CANCEL ; cancel exam
- N X,RA101Z,RAEID
- S RA101Z="RA CANCEK" ; get all protocols beginning RA CANCEL
- F  S RA101Z=$O(^ORD(101,"B",RA101Z)) Q:RA101Z'["RA CANCEL"  D
- .S RAEID=$O(^ORD(101,"B",RA101Z,0))
+ N X,RAPID,RAEID
+ S RAPID="RA CANCEK" ; get all protocols beginning RA CANCEL
+ F  S RAPID=$O(^ORD(101,"B",RAPID)) Q:RAPID'["RA CANCEL"  D
+ .S RAEID=$O(^ORD(101,"B",RAPID,0))
  .I RAEID,'$L($P(^ORD(101,RAEID,0),"^",3)) D EN^RAHLR
  Q
  ;
 RPT ; report verified or released/not verified
- N X,RA101Z,RAEID,RASSS ; RASSS subcriber array to be passed to HLL for GENERATE^HLMA
+ N X,RAPID,RAEID,RASSS ; RASSS subcriber array to be passed to HLL for GENERATE^HLMA
  ;S X="^%ET",@^%ZOSF("TRAP")
- S RA101Z="RA RPS" ; get all protocols beginning RA RPT
- F  S RA101Z=$O(^ORD(101,"B",RA101Z)) Q:RA101Z'["RA RPT"  D
- .S RAEID=$O(^ORD(101,"B",RA101Z,0)) K RASSS  ; RA*5*81
+ S RAPID="RA RPS" ; get all protocols beginning RA RPT
+ F  S RAPID=$O(^ORD(101,"B",RAPID)) Q:RAPID'["RA RPT"  D
+ .S RAEID=$O(^ORD(101,"B",RAPID,0)) K RASSS  ; RA*5*81
  .S:$L($G(RANOSEND)) RAEID=$$GETEID(RAEID,RANOSEND,.RASSS) ;RA*5*81
  .I RAEID,'$L($P(^ORD(101,RAEID,0),"^",3)) D EN^RAHLRPT
@@ -51,7 +44,6 @@
  ; RAEXEDT = Indication of editing of: proc, proc mod, req phys, CPT mod, Tech comm...
  ; RAGENHL7 = Indication that sending ORU is due...
- ; RASSSX1(IENs) = Array of subscribers from 771, the message will be sent (SCIMGE)
  ; 
- N RAIMGTYI,RAIMGTYJ,RALOWER,RANEWST,RAEXMDUN,RAGENHL7,RASSSX1
+ N RAIMGTYI,RAIMGTYJ,RALOWER,RANEWST,RAEXMDUN,RAGENHL7
  S RAIMGTYI=$P($G(^RADPT(RADFN,"DT",RADTI,0)),U,2),RAIMGTYJ=$P(^RA(79.2,RAIMGTYI,0),U),RANEWST=$P($G(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0)),U,3)
  S:$P(^RA(72,RANEWST,0),U,8)="Y" RAGENHL7=1 ;this status has GEN HL7 marked Y
@@ -61,15 +53,12 @@
  ;?? none of the lower status levels have GEN HL7 marked Y
  K:$P(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0),U,30)="Y" RAGENHL7 ;already sent
- ;Q:'$G(RAEXEDT)&'$G(RAGENHL7)
- ; Business Rule: RA*5*84 sends an examined message to ScImage unconditionally
- I '$G(RAEXEDT),'$G(RAGENHL7) Q:'$O(^RA(79.7,0))  D  Q:'$O(RASSSX1(0))
- .N X,RASSS,RASSSL S X=0 F  S X=$O(^RA(79.7,X)) Q:'X  S:$P(^(X,0),U,2) RASSS(X)=""
- .D:$D(RASSS) GETSUB^RAHLRS1(.RASSS,.RASSSX1,.RASSSL)
+ Q:'$G(RAEXEDT)&'$G(RAGENHL7)
+ ;
 1 N RAEXMDUN
  S RAEXMDUN=1
-A1 N X,RA101Z,RAEID
- S RA101Z="RA EXAMINEC" ; get all protocols beginning RA EXAMINED
- F  S RA101Z=$O(^ORD(101,"B",RA101Z)) Q:RA101Z'["RA EXAMINED"  D
- .N RAGENHL7 S RAEID=$O(^ORD(101,"B",RA101Z,0))
+A1 N X,RAPID,RAEID
+ S RAPID="RA EXAMINEC" ; get all protocols beginning RA EXAMINED
+ F  S RAPID=$O(^ORD(101,"B",RAPID)) Q:RAPID'["RA EXAMINED"  D
+ .N RAGENHL7 S RAEID=$O(^ORD(101,"B",RAPID,0))
  .I RAEID,'$L($P(^ORD(101,RAEID,0),"^",3)) D EN^RAHLR
  S:$G(RAGENHL7) $P(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0),U,30)="Y"
@@ -82,7 +71,6 @@
  ; 0 (zero) returned if No subscriber exist or all subscribers associated with RANOSEND application.
  S RAEID=$G(RAEID) Q:'RAEID!'$L($G(RANOSEND))!'$D(^ORD(101,+RAEID,0)) RAEID
- N RAXX,ERR,X1,Y1,YY,RAPL,RANEW,RAPIDS,RAIEDS,DIERR,RAERR
- S RAPL=$S(+RANOSEND:+RANOSEND,1:$$FIND1^DIC(771,"","X",RANOSEND,"","","RAERR"))
- Q:'RAPL!($D(RAERR)#2) RAEID
+ N RAXX,ERR,X1,Y1,YY,RAPL,RANEW,RAPIDS,RAIEDS
+ S RAPL=$S(+RANOSEND:+RANOSEND,1:$O(^HL(771,"B",RANOSEND,0))) Q:'RAPL RAEID
  D GETS^DIQ(101,RAEID_",","**","I","RAXX","ERR")
  Q:$D(ERR) RAEID ; Was not able get Event driver info... so just pass event driver...
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPT.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPT.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRPT.m	(revision 636)
@@ -1,4 +1,4 @@
 RAHLRPT ;HISC/CAH AISC/SAW-Compiles HL7 'ORU' Message Type ; 4/26/01 10:40am
- ;;5.0;Radiology/Nuclear Medicine;**2,12,10,25,81,80,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**2,12,10,25,81,80**;Mar 16, 1998;Build 19
 EN ; Called from RA RPT and RA RPT 2.3 protocol entry action
  ; Input variables:
@@ -10,17 +10,9 @@
  ; Output variables:
  ;   HLA("HLS", array containing HL7 msg
- ;   RATELREL = 1  Indicates that the text: 'Released for local dictation by National Teleradiology'
- ;              has been included in Impression or Report section
- ;   RATELX =   Text used as indication of Release for local dictation... if not set use defauld above...
- ;   RATELE =   1 If RANOSEND is Teleradiology type vendor
  ;
- ;Integration Agreements
- ;----------------------
- ;$$GET1^DIQ(2056); ^DIWP(10011); $$HLDATE/$$HLNAME^HLFNC(10106)
- ;GENERATE^HLMA(2164); DEM^VADPT(10061); $$FMTHL7^XLFDT(10103)
- ;$$PATCH^XPDUTL(10141); $$VERSION^XPDUTL(10141)
- ;
- N RASET,RACN0,RATELE,RATELREL,RATELX
- D INIT^RAHLRPTT ;Patch 84
+ N RASET,RACN0
+ S RASET=0
+ S RACN0=^RADPT(RADFN,"DT",RADTI,"P",RACNI,0)
+ S:'$D(RARPT) RARPT=+$P(RACN0,"^",17)
  I +$P(RACN0,U,25)=2 D  Q  ; printset
  .; loop through all cases in set and create message
@@ -37,8 +29,8 @@
  D INIT^RAHLRU ;initialize HL7 variables
  Q:+$G(HL)=15  ;no known client(item) linked to the event driver protocol
- Q:$O(HL(""))=""  ;failed return from INIT^HLFNC2 (called by INIT^RAHLRU)
+ Q:$O(HL(""))=""  ;failed return from init^hlfnc2
  ;
  ;** branch to new HL7 logic when the HL7 version surpasses 2.3 **
- I HL("VER")>2.3,($T(^RAHLRPT1))'="" D EN^RAHLRPT1(RADFN,RADTI,RACNI,RAEID),EXIT Q
+ ;I HL("VER")]2.3 D EN^RAHLRPT1(RADFN,RADTI,RACNI,RAEID),EXIT Q
  ;** branch to new HL7 logic when the HL7 version surpasses 2.3 **
  ;
@@ -49,13 +41,11 @@
  ; for an inexact date of birth.  If inexact, pass null for DOB in
  ; the 'PID' segment.  Some COTS systems can't handle inexact DOB's.
- D SETUP^RAHLRPTT,PID^RAHLRPTT,OBR,OBXPRC,OBXIMP,OBXDIA,OBXRPT,OBXMOD,OBXTCM
+ D SETUP,PID,OBR,OBXPRC,OBXIMP,OBXDIA,OBXRPT,OBXMOD,OBXTCM
 EXIT ; set HL7 message type & return to RA RPT protocol
- ;For P84 see if this is a >>Released for local reading<< type report and if yes resend the ORM (^RAHLRS1)...
- I $G(RATELREL) D RESEND^RAHLRPTT(RADFN,RADTI,RACNI) Q  ;P84 resend in the case that report released from Telerad
  S HL("MTN")="ORU"
  N HLEID,HLARYTYP,HLFORMAT,HLMTIEN,HLP
  S HLEID=RAEID,HLARYTYP="LM",HLFORMAT=1,HLMTIEN="",HLP("PRIORITY")="I"
  M:$D(RASSS) HLP=RASSS
- D:$D(RASSSX(HLEID)) GETHLP^RAHLRS1(HLEID,.HLP,"RASSSX")
+ D:$D(RASSSX(HLEID)) GETHLP^RAHLRS1(HLEID,.HLP)
  D GENERATE^HLMA(HLEID,HLARYTYP,HLFORMAT,.HLRESLT,HLMTIEN,.HLP)
  K RAVADM
@@ -102,5 +92,5 @@
  S $P(X1,HLFS,35)="" I $O(^RADPT(RADFN,"DT",RADTI,"P",RACNI,"TC",0)) D
  .S X2=$O(^RADPT(RADFN,"DT",RADTI,"P",RACNI,"TC",0)) I X2']"" Q
- .S X2=$P($G(^RADPT(RADFN,"DT",RADTI,"P",RACNI,"TC",X2,0)),"^",1) I X2']"" Q
+ .S X2=$G(^RADPT(RADFN,"DT",RADTI,"P",RACNI,"TC",X2,0)) I X2']"" Q
  .S XX2=$$GET1^DIQ(200,X2,.01) Q:XX2']""
  .S Y=$$HLNAME^HLFNC(XX2) I Y']"" Q
@@ -108,10 +98,10 @@
  ;Transcriptionist
  S $P(X1,HLFS,36)="" I $G(^RARPT(RARPT,"T")) D
- .S X2=$$GET1^DIQ(200,$P(^RARPT(RARPT,"T"),"^",1),.01) I X2']"" Q
+ .S X2=$$GET1^DIQ(200,^RARPT(RARPT,"T"),.01) I X2']"" Q
  .S Y=$$HLNAME^HLFNC(X2) I Y']"" Q
  .S $P(X1,HLFS,36)=^RARPT(RARPT,"T")_$E(HLECH)_Y
  ;
  ; if long str, break so 2nd str begins with separator to avoid abend
- N RAPART I $L(X1)>245 F RAPART=5:1:18 S RAPART(1)=$P(X1,HLFS,1,RAPART),RAPART(2)=$P(X1,HLFS,RAPART+1,99) Q:$L(RAPART(1))<245&($L(RAPART(2))<245)&($P(RAPART(2),HLFS)="")
+ I $L(X1)>245 N RAPART F RAPART=5:1:18 S RAPART(1)=$P(X1,HLFS,1,RAPART),RAPART(2)=$P(X1,HLFS,RAPART+1,99) Q:$L(RAPART(1))<245&($L(RAPART(2))<245)&($P(RAPART(2),HLFS)="")
  I $D(RAPART) K:RAPART=18 RAPART ;if RAPART reaches 18, then something's wrong, so kill RAPART to allow abend due "string too long"
  S RAN=RAN+1
@@ -146,6 +136,5 @@
 OBXIMP ;Compile 'OBX' segment for Impression
  I '$O(^RARPT(RARPT,"I",0)) S RAN=RAN+1,HLA("HLS",RAN)="OBX"_HLFS_HLFS_"TX"_HLFS_"I"_$E(HLECH)_"IMPRESSION"_$E(HLECH)_"L"_HLFS_HLFS_"None Entered" D OBX11^RAHLRU Q
- K ^UTILITY($J,"W") S DIWF="",DIWR=80,DIWL=1
- F RAI=0:0 S RAI=$O(^RARPT(RARPT,"I",RAI)) Q:'RAI  I $D(^(RAI,0)) S X=^(0) D RATELREL,^DIWP
+ K ^UTILITY($J,"W") S DIWF="",DIWR=80,DIWL=1 F RAI=0:0 S RAI=$O(^RARPT(RARPT,"I",RAI)) Q:'RAI  I $D(^(RAI,0)) S X=^(0) D ^DIWP
  F RAI=0:0 S RAI=$O(^UTILITY($J,"W",DIWL,RAI)) Q:'RAI  I $D(^(RAI,0)) S RAN=RAN+1,HLA("HLS",RAN)="OBX"_HLFS_HLFS_"TX"_HLFS_"I"_$E(HLECH)_"IMPRESSION"_$E(HLECH)_"L"_HLFS_HLFS_^(0) D OBX11^RAHLRU
  Q
@@ -156,16 +145,26 @@
  S RAN=RAN+1 D OBXPRC^RAHLRU
  Q
-OBXTCM ;Compile 'OBX' Segment for Tech Comments
+OBXTCM ; Compile 'OBX' Segment for Tech Comments
  D OBXTCM^RAHLRU
  Q
 OBXRPT ;Compile 'OBX' Segment for Radiology Report Text
  I '$O(^RARPT(RARPT,"R",0)) S RAN=RAN+1,HLA("HLS",RAN)="OBX"_HLFS_HLFS_"TX"_HLFS_"R"_$E(HLECH)_"REPORT"_$E(HLECH)_"L"_HLFS_HLFS_"None Entered" D OBX11^RAHLRU Q
- K ^UTILITY($J,"W") S DIWF="",DIWR=80,DIWL=1
- F RAI=0:0 S RAI=$O(^RARPT(RARPT,"R",RAI)) Q:'RAI  I $D(^(RAI,0)) S X=^(0) D RATELREL,^DIWP
+ K ^UTILITY($J,"W") S DIWF="",DIWR=80,DIWL=1 F RAI=0:0 S RAI=$O(^RARPT(RARPT,"R",RAI)) Q:'RAI  I $D(^(RAI,0)) S X=^(0) D ^DIWP
  F RAI=0:0 S RAI=$O(^UTILITY($J,"W",DIWL,RAI)) Q:'RAI  I $D(^(RAI,0)) S RAN=RAN+1,HLA("HLS",RAN)="OBX"_HLFS_HLFS_"TX"_HLFS_"R"_$E(HLECH)_"REPORT"_$E(HLECH)_"L"_HLFS_HLFS_^(0) D OBX11^RAHLRU
  ; Replace above with following when Imaging can cope with ESC chars
  ; F RAI=0:0 S RAI=$O(^UTILITY($J,"W",DIWL,RAI)) Q:'RAI  I $D(^(RAI,0)) S RAN=RAN+1,HLA("HLS",RAN)="OBX"_HLFS_HLFS_"TX"_HLFS_"R"_$E(HLECH)_"REPORT"_$E(HLECH)_"L"_HLFS_HLFS_$$ESCAPE^RAHLRU(^(0)) D OBX11^RAHLRU
  Q
-RATELREL ;Release the study for local reading
- I $G(RATELE),X[$G(RATELX) S RATELREL=1 Q
- ; 
+PID ;Compile 'PID' Segment
+ I HL("VER")']"2.2" D
+ .S X1="",X1="PID"_HLFS_HLFS_$G(VA("PID"))_HLFS_Y_HLFS_HLFS S X=VADM(1),Y=$$HLNAME^HLFNC(X) S X1=X1_Y_HLFS_HLFS
+ .S X=RAVADM(3),Y=$$HLDATE^HLFNC(X) S X1=X1_Y_HLFS_$S(VADM(5)]"":$S("MF"[$P(VADM(5),"^"):$P(VADM(5),"^"),1:"O"),1:"U") S:$P(VADM(2),"^")]"" $P(X1,HLFS,20)=$P(VADM(2),"^") S RAN=RAN+1,HLA("HLS",RAN)=X1
+ I HL("VER")]"2.2" S RAN=RAN+1,HLA("HLS",RAN)=$$EN^VAFHLPID(DFN,"2,3,5,7,8,19,20")
+ Q
+SETUP ; Setup basic examination information
+ S:RASET RACN0=^RADPT(RADFN,"DT",RADTI,"P",RACNI,0)
+ S RADTE0=9999999.9999-RADTI,RADTECN=$E(RADTE0,4,7)_$E(RADTE0,2,3)_"-"_+RACN0,RARPT0=^RARPT(RARPT,0)
+ S RAPROC=+$P(RACN0,U,2),RAPROCIT=+$P($G(^RAMIS(71,RAPROC,0)),U,12),RAPROCIT=$P(^RA(79.2,RAPROCIT,0),U,1)
+ S RAPRCNDE=$G(^RAMIS(71,+RAPROC,0)),RACPT=+$P(RAPRCNDE,U,9)
+ S RACPTNDE=$$NAMCODE^RACPTMSC(RACPT,DT)
+ S Y=$$HLDATE^HLFNC(RADTE0) S RADTE0=$S(Y:Y,1:HLQ),Y=$$M11^HLFNC(RADFN)
+ Q
Index: FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRS1.m
===================================================================
--- FOIAVistA/trunk/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRS1.m	(revision 631)
+++ FOIAVistA/tag/r/RADIOLOGY_NUCLEAR_MEDICINE-RA/RAHLRS1.m	(revision 636)
@@ -1,12 +1,6 @@
 RAHLRS1 ;HIRMFO/ROB/PAVEL - Resend HL7 messages for selected Timeframe ; 4/2/07 3:42pm
- ;;5.0;Radiology/Nuclear Medicine;**80,84**;Mar 16, 1998;Build 13
+ ;;5.0;Radiology/Nuclear Medicine;**80**;Mar 01, 2007;Build 19
+ ;
  ; Utility to RESEND HL7 messages for selected Timeframe
- ;
- ;Integration Agreements
- ;----------------------
- ;^%DT(10003); C^%DTC(10000); H^%DTC(10000); ^%ZISC(10089); ^%ZTLOAD(10063); $$GET1^DIQ(2056)
- ;^DIR(10026); ^XMD(10070)
- ;all access to ^ORD(101 to maintain application specific protocols(872)
- ;read w/FileMan HL7 APPLICATION PARAMETER(10136)
  ;
  N RACNI,RADFN,RADTI,RARPT,X,RAED,RABD,RASHBD,RASHED,RASHTD,RASHTM,DIC,DA,XX,YY
@@ -30,10 +24,9 @@
  S RAED=RAED_"."_9999
  K XX G:'$$GETAP(.XX) STOP
- W !!,"*** Pick the application in which to send the radiology data ***",!!
+ W !!,"****Pick the application to send the RAD data to*****",!!
  F I=1:1 Q:'$D(XX(I))  W !,"  #",I,"   ",$O(XX(I,""))
-2 ;user selects the application
- S DIR(0)="N^1:"_(I-1)
- W ! S DIR("?")="Please select an available application from the list."
- D ^DIR Q:$D(DIRUT)
+2 S DIR(0)="N"
+ W ! S DIR("?")="Please select an available application from the list"
+ D ^DIR Q:$D(DIRUT)  I (X'<1),(X'<I) W "Please select an available application from the list" G 2
  W !!,"The: ",$O(XX(+X,"")),"   will be the recipient"
  W !!,"Reviewing exams for selected time period... (This may take a few minutes)... "
@@ -53,13 +46,13 @@
  W !,"Task ",$S('$D(ZTSK):" Has Not been Tasked !!!",1:"#:"_ZTSK_" Has been Tasked")
  D:$D(ZTSK)
- .N RAX,RAMPG,XMSUB,XMY,XMTEXT
- .S RAX(1)="Task #"_$G(ZTSK)_" is scheduled to run the option: "
- .S RAX(2)=">>Re-send HL7 messages for a date range and for designated Recipient.<<"
- .S RAX(3)=" Scheduled time to run: "_RASHTM
- .S RAX(4)="Date range from: "_$G(RASHBD)_" to: "_$G(RASHED)
+ .N X,RAMPG,XMSUB,XMY,XMTEXT
+ .S X(1)="Task #"_$G(ZTSK)_" is scheduled to run the option: "
+ .S X(2)=">>Re-send HL7 messages for a date range and for designated Recipient.<<"
+ .S X(3)=" Scheduled time to run: "_RASHTM
+ .S X(4)="Date range from: "_$G(RASHBD)_" to: "_$G(RASHED)
  .S XMSUB="TASKMAN SCHEDULE NOTIFICATION/INFO"
  .S RAMPG="G.RAD HL7 MESSAGES"
  .S XMY(RAMPG)="",XMDUZ=.5
- .S XMTEXT="RAX("
+ .S XMTEXT="X("
  .D ^XMD
  Q
@@ -72,14 +65,14 @@
  ..S RADTI=0 F  S RADTI=$O(^RADPT("AR",RABD,RADFN,RADTI)) Q:'RADTI  D
  ...S RACNI=0 F  S RACNI=$O(^RADPT(RADFN,"DT",RADTI,"P",RACNI)) Q:'RACNI  D RESEND(RADFN,RADTI,RACNI)
- K RAX S RAX(1)="Task #"_$G(ZTSK)_" successfully completed the option: "
- S RAX(2)=">>Re-send HL7 messages for a date range and for designated Recipient.<<"
- S RAX(3)="Date range from: "_$G(RASHBD)_" to: "_$G(RASHED)
- S RAX(4)="# Of RAD Reports transferred: "_$G(RASUM7R)
- S RAX(5)="# Of Exams transferred:      "_$G(RASUM7)
+ K X S X(1)="Task #"_$G(ZTSK)_" successfully completed the option: "
+ S X(2)=">>Re-send HL7 messages for a date range and for designated Recipient.<<"
+ S X(3)="Date range from: "_$G(RASHBD)_" to: "_$G(RASHED)
+ S X(4)="# Of RAD Reports transferred: "_$G(RASUM7R)
+ S X(5)="# Of Exams transferred:      "_$G(RASUM7)
  S:$G(RASUM7E) X(6)="# Of Exams not transferred because of ""BAD DATA"": "_$G(RASUM7E)
  S XMSUB="TASKMAN ""RESEND HL7 OPTION"" COMPLETED/INFO"
  S RAMPG="G.RAD HL7 MESSAGES"
  S XMY(RAMPG)="",XMDUZ=.5
- S XMTEXT="RAX("
+ S XMTEXT="X("
  D ^XMD
  G STOP
@@ -88,21 +81,21 @@
 RESEND(RADFN,RADTI,RACNI) ; re-send exam message(s) to HL7 subscribers
  ; for every 10 messages sent, make sure queue is not clogged... $$HANG
- N RAXAMP80 S RAXAMP80=$G(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0))
- I '(+$P(RAXAMP80,U))!'($P(RAXAMP80,U,2)) S RASUM7E=RASUM7E+1 Q
- N RABD,RAEDP80,QUIT
+ I '(+^(RACNI,0)) S RASUM7E=RASUM7E+1 Q
+ I '$P(^(0),U,2) S RASUM7E=RASUM7E+1 Q
+ N RABD,RAED,QUIT
  ;
  I '$D(DT) D ^%DT S DT=Y
  ;
- S RAEDP80=$$RAED(RADFN,RADTI,RACNI)
- I '$L(RAEDP80) S RASUM7E=RASUM7E+1 Q
- D:RAEDP80[",REG,"
+ S RAED=$$RAED(RADFN,RADTI,RACNI)
+ I '$L(RAED) S RASUM7E=RASUM7E+1 Q
+ D:RAED[",REG,"
  .D CHSUM N RASUM7,RASUM7R,RASUM7E D REG^RAHLRPC
- D:RAEDP80[",CANCEL,"
+ D:RAED[",CANCEL,"
  .D CHSUM N RASUM7,RASUM7R,RASUM7E D CANCEL^RAHLRPC
- D:RAEDP80[",EXAM,"
+ D:RAED[",EXAM,"
  .D CHSUM
  .S $P(^RADPT(RADFN,"DT",RADTI,"P",RACNI,0),"^",30)="" ;Reset sent flag
  .N RASUM7,RAEXMDUN,RASUM7R,RASUM7E D 1^RAHLRPC
- D:RAEDP80[",RPT,"
+ D:RAED[",RPT,"
  .D CHSUM N RASUM7,RANOSEND,RASUM7R,RASUM7E,RARPT D RPT^RAHLRPC
  Q
@@ -153,11 +146,6 @@
  .F  S X1=$O(^ORD(101,"B",X1)) Q:X1'[X11  S X2=$O(^ORD(101,"B",X1,0)) Q:'X2  D
  ..K Z S X3=0 F  S X3=$O(^ORD(101,X2,775,X3)) Q:'X3  S Z(+^(X3,0))=""
- ..Q:'$D(Z)  K Z1 S X3=0 F  S X3=$O(Z(X3)) Q:'X3  D
- ...S Z1=$G(^ORD(101,X3,770)) S:+$P(Z1,U,2) XXX(+$P(Z1,U,2))=""
- S X1=0 F J=1:1 S X1=$O(XXX(X1)) Q:'X1  D
- .N DIERR,RAERR,Y
- .S Y=$$GET1^DIQ(771,X1,.01,"","","RAERR")
- .Q:Y=""!($D(RAERR)#2)  S XX(J,Y)=X1
- .Q
+ ..Q:'$D(Z)  K Z1 S X3=0 F  S X3=$O(Z(X3)) Q:'X3  S XXX(+$P($G(^ORD(101,X3,770)),U,2))=""
+ S X1=0 F J=1:1 S X1=$O(XXX(X1)) Q:'X1  S XX(J,$P(^HL(771,X1,0),U))=X1
  Q $S($D(XXX):1,1:0)
  ;
@@ -176,10 +164,7 @@
  ...S XX=+$P($G(^ORD(101,XX,770)),U,7) S:XX LINK(XX)=""
  Q
-GETHLP(RAEID,HLP,ADR) ; Get excluded subcribers set into HLP array
- N I,J,XX,AA S J=$O(HLP("EXCLUDE SUBSCRIBER",99999999),-1)
- ;XX Set the list of already excluded subscribers, so be sure we don't set it second time
- S AA=ADR_"("_RAEID_",I)"
- S I=0 F I=$O(HLP("EXCLUDE SUBSCRIBER",I)) Q:'I  S XX(HLP("EXCLUDE SUBSCRIBER",I))=""
- S I=0 F  S I=$O(@AA) Q:'I  S:'$D(XX(I)) J=J+1,HLP("EXCLUDE SUBSCRIBER",J)=I
+GETHLP(RAEID,HLP) ; Get excluded subcribers set into HLP array
+ N I,J,II S II=$O(HLP("EXCLUDE SUBSCRIBER",99999999),-1)+1
+ S I=0 F J=II:1 S I=$O(RASSSX(RAEID,I)) Q:'I  S HLP("EXCLUDE SUBSCRIBER",J)=I
  Q
 CHSUM ;CHECKSUM
